/*
Copyright (c) 2002 Nicolai Haehnle

See the license.txt for details. If that file was not included in the
source distributions, please email <prefect@rtts.org>
*/
// ff_level.h

#define LVL_MAGIC		('u' | ('-' << 8) | ('v' << 16) | (140 << 24))
#define LVL_VERSION		1

// Header:
//  (int) Magic
//  (int) Version
//  (int) Level #
//  (cstr) Name
//  (int) Length
//  (byte) Playable
//  (int) Features Flag
//
// Tile types
//  (int) # tile types
//  Repeat for #
//   (cstr) Tile name
//
// Tile gfx info
//  (int) # of lines in map
//  Repeat for # of tiles
//   (int) gfx
//

#define LVL_FEAT_AIRJOBS			(1<<0)
#define LVL_FEAT_LEVELS				(1<<1)
#define LVL_FEAT_AUTHOR				(1<<2)

// if feature author
//  (cstr) Author

// if feature airjob:
//  Airjob info:
//   (cstr) typename (if string is empty -> end of list)
//   (float) x
//   (float) y
//   (byte) level (if in featureset)
//   (byte) # nodes
//   For # nodes
//    (float) dx
//    (float) dy
//   Repeat
//
