/*
Copyright (c) 2002 Nicolai Haehnle

See the license.txt for details. If that file was not included in the
source distributions, please email <prefect@rtts.org>
*/
// gui_popupmenu.h

#ifndef GUI_POPUPMENU_H
#define GUI_POPUPMENU_H

#include "gui_menu.h"

/*
A popup-menu presents the user with a list of choices which he can click on
to trigger an action (this uses a signal)
*/
class GPopupMenu : public GMenu {
public:
	GPopupMenu();
	~GPopupMenu();
	
	void Display(int x, int y);
	void DisplayNearMouse();

protected:
	virtual void Begin();
	virtual void End();
	
	virtual void Draw();

	virtual bool MouseButton(int btn, int x, int y, bool down);
	virtual void MouseMove(int x, int y);
	
private:
	void TrackMouse(int x, int y);
	
	int		m_iHighlighted;
};

#endif // GUI_BUTTON_H
