/*
Copyright (c) 2002 Nicolai Haehnle

See the license.txt for details. If that file was not included in the
source distributions, please email <prefect@rtts.org>
*/
// hal_sdlgl.h

class HAL_SdlGl : public HAL {
public:
	int		init_res, init_bpp;
	bool	init_window;

	bool	showfps;

public:
	HAL_SdlGl(LConfig *cfg);

	virtual void Init();
	virtual void Shutdown();

	virtual void StartFrame();
	virtual void EndFrame();
	virtual void Input(const hal_inputcb_t *cb);
	virtual byte *GetKeyState();
	virtual unsigned GetMouseState(int *px, int *py);

	virtual void Ortho(int x, int y, int w, int h);
	virtual void SetDrawRect(int x, int y, int w, int h, int ofsx, int ofsy);

	virtual void SetAlphaOnly(bool on);

	virtual void FillRect(int x, int y, int w, int h, int r, int g, int b, int a);
	virtual void DrawLine(float x1, float y1, float x2, float y2, int r, int g, int b, int a);

	virtual byte *Screenshot(int *size);

private:
	virtual void LoadPicture(HPicture *pic);
	virtual void UnloadPicture(HPicture *pic);
};
