// regexp job from keycodes.h
typedef struct {
	char *name;
	int code;
} keynamecode_t;

keynamecode_t keynames[] = {
	/* The keyboard syms have been cleverly chosen to map to ASCII */
	{ "UNKNOWN", 0 },
	{ "FIRST", 0 },
	{ "BACKSPACE", 8 },
	{ "TAB", 9 },
	{ "CLEAR", 12 },
	{ "RETURN", 13 },
	{ "PAUSE", 19 },
	{ "ESCAPE", 27 },
	{ "SPACE", 32 },
	{ "EXCLAIM", 33 },
	{ "QUOTEDBL", 34 },
	{ "HASH", 35 },
	{ "DOLLAR", 36 },
	{ "AMPERSAND", 38 },
	{ "QUOTE", 39 },
	{ "LEFTPAREN", 40 },
	{ "RIGHTPAREN", 41 },
	{ "ASTERISK", 42 },
	{ "PLUS", 43 },
	{ "COMMA", 44 },
	{ "MINUS", 45 },
	{ "PERIOD", 46 },
	{ "SLASH", 47 },
	{ "0", 48 },
	{ "1", 49 },
	{ "2", 50 },
	{ "3", 51 },
	{ "4", 52 },
	{ "5", 53 },
	{ "6", 54 },
	{ "7", 55 },
	{ "8", 56 },
	{ "9", 57 },
	{ "COLON", 58 },
	{ "SEMICOLON", 59 },
	{ "LESS", 60 },
	{ "EQUALS", 61 },
	{ "GREATER", 62 },
	{ "QUESTION", 63 },
	{ "AT", 64 },
	/*
	   Skip uppercase letters
	 */
	{ "LEFTBRACKET", 91 },
	{ "BACKSLASH", 92 },
	{ "RIGHTBRACKET", 93 },
	{ "CARET", 94 },
	{ "UNDERSCORE", 95 },
	{ "BACKQUOTE", 96 },
	{ "a", 97 },
	{ "b", 98 },
	{ "c", 99 },
	{ "d", 100 },
	{ "e", 101 },
	{ "f", 102 },
	{ "g", 103 },
	{ "h", 104 },
	{ "i", 105 },
	{ "j", 106 },
	{ "k", 107 },
	{ "l", 108 },
	{ "m", 109 },
	{ "n", 110 },
	{ "o", 111 },
	{ "p", 112 },
	{ "q", 113 },
	{ "r", 114 },
	{ "s", 115 },
	{ "t", 116 },
	{ "u", 117 },
	{ "v", 118 },
	{ "w", 119 },
	{ "x", 120 },
	{ "y", 121 },
	{ "z", 122 },
	{ "DELETE", 127 },
	/* End of ASCII mapped keysyms */

	/* International keyboard syms */
	{ "WORLD", 160 },		/* 0xA0 */
	{ "WORLD", 161 },
	{ "WORLD", 162 },
	{ "WORLD", 163 },
	{ "WORLD", 164 },
	{ "WORLD", 165 },
	{ "WORLD", 166 },
	{ "WORLD", 167 },
	{ "WORLD", 168 },
	{ "WORLD", 169 },
	{ "WORLD", 170 },
	{ "WORLD", 171 },
	{ "WORLD", 172 },
	{ "WORLD", 173 },
	{ "WORLD", 174 },
	{ "WORLD", 175 },
	{ "WORLD", 176 },
	{ "WORLD", 177 },
	{ "WORLD", 178 },
	{ "WORLD", 179 },
	{ "WORLD", 180 },
	{ "WORLD", 181 },
	{ "WORLD", 182 },
	{ "WORLD", 183 },
	{ "WORLD", 184 },
	{ "WORLD", 185 },
	{ "WORLD", 186 },
	{ "WORLD", 187 },
	{ "WORLD", 188 },
	{ "WORLD", 189 },
	{ "WORLD", 190 },
	{ "WORLD", 191 },
	{ "WORLD", 192 },
	{ "WORLD", 193 },
	{ "WORLD", 194 },
	{ "WORLD", 195 },
	{ "WORLD", 196 },
	{ "WORLD", 197 },
	{ "WORLD", 198 },
	{ "WORLD", 199 },
	{ "WORLD", 200 },
	{ "WORLD", 201 },
	{ "WORLD", 202 },
	{ "WORLD", 203 },
	{ "WORLD", 204 },
	{ "WORLD", 205 },
	{ "WORLD", 206 },
	{ "WORLD", 207 },
	{ "WORLD", 208 },
	{ "WORLD", 209 },
	{ "WORLD", 210 },
	{ "WORLD", 211 },
	{ "WORLD", 212 },
	{ "WORLD", 213 },
	{ "WORLD", 214 },
	{ "WORLD", 215 },
	{ "WORLD", 216 },
	{ "WORLD", 217 },
	{ "WORLD", 218 },
	{ "WORLD", 219 },
	{ "WORLD", 220 },
	{ "WORLD", 221 },
	{ "WORLD", 222 },
	{ "WORLD", 223 },
	{ "WORLD", 224 },
	{ "WORLD", 225 },
	{ "WORLD", 226 },
	{ "WORLD", 227 },
	{ "WORLD", 228 },
	{ "WORLD", 229 },
	{ "WORLD", 230 },
	{ "WORLD", 231 },
	{ "WORLD", 232 },
	{ "WORLD", 233 },
	{ "WORLD", 234 },
	{ "WORLD", 235 },
	{ "WORLD", 236 },
	{ "WORLD", 237 },
	{ "WORLD", 238 },
	{ "WORLD", 239 },
	{ "WORLD", 240 },
	{ "WORLD", 241 },
	{ "WORLD", 242 },
	{ "WORLD", 243 },
	{ "WORLD", 244 },
	{ "WORLD", 245 },
	{ "WORLD", 246 },
	{ "WORLD", 247 },
	{ "WORLD", 248 },
	{ "WORLD", 249 },
	{ "WORLD", 250 },
	{ "WORLD", 251 },
	{ "WORLD", 252 },
	{ "WORLD", 253 },
	{ "WORLD", 254 },
	{ "WORLD", 255 },		/* 0xFF */

	/* Numeric keypad */
	{ "KP0", 256 },
	{ "KP1", 257 },
	{ "KP2", 258 },
	{ "KP3", 259 },
	{ "KP4", 260 },
	{ "KP5", 261 },
	{ "KP6", 262 },
	{ "KP7", 263 },
	{ "KP8", 264 },
	{ "KP9", 265 },
	{ "KP", 266 },
	{ "KP", 267 },
	{ "KP", 268 },
	{ "KP", 269 },
	{ "KP", 270 },
	{ "KP", 271 },
	{ "KP", 272 },

	/* Arrows + Home/End pad */
	{ "UP", 273 },
	{ "DOWN", 274 },
	{ "RIGHT", 275 },
	{ "LEFT", 276 },
	{ "INSERT", 277 },
	{ "HOME", 278 },
	{ "END", 279 },
	{ "PAGEUP", 280 },
	{ "PAGEDOWN", 281 },

	/* Function keys */
	{ "F1", 282 },
	{ "F2", 283 },
	{ "F3", 284 },
	{ "F4", 285 },
	{ "F5", 286 },
	{ "F6", 287 },
	{ "F7", 288 },
	{ "F8", 289 },
	{ "F9", 290 },
	{ "F10", 291 },
	{ "F11", 292 },
	{ "F12", 293 },
	{ "F13", 294 },
	{ "F14", 295 },
	{ "F15", 296 },

	/* Key state modifier keys */
	{ "NUMLOCK", 300 },
	{ "CAPSLOCK", 301 },
	{ "SCROLLOCK", 302 },
	{ "RSHIFT", 303 },
	{ "LSHIFT", 304 },
	{ "RCTRL", 305 },
	{ "LCTRL", 306 },
	{ "RALT", 307 },
	{ "LALT", 308 },
	{ "RMETA", 309 },
	{ "LMETA", 310 },
	{ "LSUPER", 311 },		/* Left "Windows" key */
	{ "RSUPER", 312 },		/* Right "Windows" key */
	{ "MODE", 313 },		/* "Alt Gr" key */
	{ "COMPOSE", 314 },		/* Multi-key compose key */

	/* Miscellaneous function keys */
	{ "HELP", 315 },
	{ "PRINT", 316 },
	{ "SYSREQ", 317 },
	{ "BREAK", 318 },
	{ "MENU", 319 },
	{ "POWER", 320 },		/* Power Macintosh power key */
	{ "EURO", 321 },		/* Some european keyboards */
	{ "UNDO", 322 },		/* Atari keyboard has Undo */

	/* Add any other keys here */

	{ 0, 0 }
};
