/*
Copyright (c) 2002 Nicolai Haehnle

See the license.txt for details. If that file was not included in the
source distributions, please email <prefect@rtts.org>
*/
// rtts.h

#include "library.h"
#include "hal.h"

extern int parm_res;
extern bool parm_windowed;
extern bool parm_16bpp;
extern bool parm_nosubpixel;
extern bool parm_noborder;

#define LOGICTIME		30

/*
==============================================================================

GAME - BRIEFING SCREENS, ETC...

==============================================================================
*/

typedef struct plrcontrol_s {
	float	speed; // pxls / second
	int		up, down, left, right;
	int		fire;
	int		weaponswitch;
} plrcontrol_t;

#define WEAP_ROCKET			0
#define WEAP_DUMBFIRE		1
#define WEAP_ATG			2
#define WEAP_SMLASER		3
#define NUM_WEAP			4

typedef struct player_s {
	char			name[32];
	char			callsign[16];
	int				level;
	int				money;
	int				health;
	byte			weapons[NUM_WEAP];
} player_t;

typedef struct game_s {
	bool		running;
	player_t	player;
} game_t;

extern game_t game;

//
// game.c
//
void G_NewGame(const char *playername, const char *callsign);
void G_EndGame();
void G_SavePlayer(const player_t *plr);
bool G_LoadPlayer(player_t *plr, const char *filename);
void G_Init();
void G_Shutdown();

//
// ge_main.c
//
//void GE_Start();

/*
==============================================================================

COMMON FUNCTIONS

==============================================================================
*/

#define TAG_MAP				102
#define TAG_UNIT			104
#define TAG_EDITOR			105

extern LConfig *config;

void MainMenu_Run();
